///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

char UserKey[10240 + 1];
char KeyHash[10240 + 1];

int UserKeySize = 0;
int KeyHashSize = 512;

_NASCCL NASCCL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL InitilizeSecurity(void)
{
    int Flags = ROUNDMUTATION | SWAPMATRIX | ROUNDRESULT | NONREPETITION | ENSUREOFFSET | FMATRIXMUTATION | RMATRIXMUTATION | CMATRIXMUTATION | CRYPTFULLDATASET;

    UserKeySize = strlen(UserKey);
    KeyHashSize = 512;

    if(!HashKey(UserKey, KeyHash, UserKeySize, KeyHashSize))
    {
        return FALSE;
    }

    if(!InitializeCryptographySet(&NASCCL, KeyHash, KeyHashSize, Flags))
    {
        return FALSE;
    }

    NASCCL.InData  = (char *) calloc(1024 + 1, 1);
    NASCCL.OutData = (char *) calloc(1024 + 1, 1);

    sprintf(NASCCL.InData, "Hello World");

    NASCCL.SizeOfData = strlen(NASCCL.InData);

    Encode(&NASCCL);

//    ErrorMessage(NULL, NASCCL.OutData);

    return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL UnInitilizeSecurity(void)
{
    if(!UninitializeCryptographySet(&NASCCL))
    {
        return FALSE;
    }

    return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

